
/* Fancy Clear Screen - V1.00 - 09APR88 - Colin Walls (c) 1988 */

char  *vers = "V1.00";

#include <dos.h>

struct BYTEREGS  regs;

char  cl_flags[500];

main(argc, argv)
int   argc;
char  *argv[];
{
   int   top, bottom, left, right;
   int   slug, count;
   char  type, *cp, *getenv();

   cp = getenv("FCLS");
   type = (argc==1) ? ((cp) ? toupper(*cp) : '?') : toupper(argv[1][0]);

   switch (type)
   {
      case 'E':               /* explosion */
         left=33;
         right=46;
         top=11;
         bottom=13;
         for (count=0; count<12; count++)
         {
            clear(left, top, right, bottom);
            top--;
            bottom++;
            left -= 3;
            right += 3;
            for (slug=0; slug<300; slug++)
               ;
         }
         break;
      case 'I':               /* implosion */
         left=6;
         right=73;
         top=0;
         bottom=24;
         for (count=0; count<12; count++)
         {
            clear(0, 0, left, 24);
            clear(right, 0, 79, 24);
            clear(0, 0, 79, top);
            clear(0, bottom, 79, 24);
            top++;
            bottom--;
            left += 3;
            right -= 3;
            for (slug=0; slug<300; slug++)
               ;
         }
         break;
      case 'V':               /* vertical */
         for (left=39, right=40; left>=0; left--, right++)
            clear(left, 0, right, 24);
         break;
      case 'H':               /* horizontal */
         for (top=12, bottom=12; top>=0; top--, bottom++)
         {
            clear(0, top, 79, bottom);
            for (slug=0; slug<1000; slug++)
               ;
         }
         break;
      case 'F':               /* fade */
         count=500;
         do
         {
            while((left=(rand()&0x1ff))>=500)
               ;
            if (!cl_flags[left])
            {
               cl_flags[left]=1;
               count--;
               top = (left/40)*2;
               bottom = top+1;
               left = (left % 40) * 2;
               right = left+1;
               clear(left, top, right, bottom);
            }
         }
         while (count);
         break;
      case 'C':               /* collapse */
         for (left=0, right=79; left<39; left++, right--)
         {
            clear(0, 0, left, 24);
            clear(right, 0, 79, 24);
         }
         for (top=0, bottom=24; top<13; top++, bottom--)
         {
            for (slug=0; slug<3000; slug++)
               ;
            clear(39, 0, 40, top);
            clear(39, bottom, 40, 24);
         }
         break;
      case 'S':               /* scroll */
         for (count=0; count<13; count++)
         {
            scroll(0, 0, 24, 11, 1);
            scroll(25, 0, 54, 11, -1);
            scroll(55, 0, 79, 11, 1);
            scroll(0, 12, 24, 24, -1);
            scroll(25, 12, 54, 24, 1);
            scroll(55, 12, 79, 24, -1);
         }
         break;
      case '?':               /* help */
         printf("\n\t\tFancy Clear Screen - %s  Colin Walls (c) 1988\n\n", 
               vers);
         printf("\t\tA less boring alternative to the DOS CLS command.\n");
         printf("\t\tThe following commands are valid:\n\n");
         printf("\t\tFCLS E   -  Explode the screen.\n");
         printf("\t\tFCLS I   -  Implode the screen.\n");
         printf("\t\tFCLS V   -  Vertically sweep the screen.\n");
         printf("\t\tFCLS H   -  Horizontally sweep the screen.\n");
         printf("\t\tFCLS F   -  Fade (randomly) the screen.\n");
         printf("\t\tFCLS C   -  Collapse the screen.\n");
         printf("\t\tFCLS S   -  Scroll off the screen.\n");
         printf("\t\tFCLS ?   -  Help!!\n");
         exit(0);
         break;
      default:                /* error */
         printf("** Invalid Parameter.\n");
         printf("** Type FCLS ? for help.\n");
         exit(1);
         break;
   }

   regs.ah = 2;               /* home the cursor */
   regs.dh = 0;
   regs.dl = 0;
   regs.bh = 0;
   int86(16, &regs, &regs);
}

/* Function to clear an area of screen */

clear(left_col, top_row, right_col, bottom_row)
int   left_col, top_row, right_col, bottom_row;
{
   scroll(left_col, top_row, right_col, bottom_row, 0);  /* 0 line scroll */
#ifdef   DEBUG
   printf("left=%d right=%d top=%d bottom=%d\n", 
         left_col, right_col, top_row, bottom_row);
#endif
}

/* Function to scroll an area of screen up or down */

scroll(left_col, top_row, right_col, bottom_row, lines)
int   left_col, top_row, right_col, bottom_row, lines;
{
   if (lines>=0)              /* use ROM BIOS window scroll */
      regs.ah=6;              /* up */
   else
   {
      regs.ah=7;              /* down */
      lines = -lines;
   }
   regs.al = lines;
   regs.ch = top_row;
   regs.cl = left_col;
   regs.dh = bottom_row;
   regs.dl = right_col;
   regs.bh = 7;
   int86(16, &regs, &regs);
#ifdef   DEBUG
   printf("left=%d right=%d top=%d bottom=%d\n", 
         left_col, right_col, top_row, bottom_row);
#endif
}
